diff --git a/sys/dev/bnxt/bnxt_hwrm.c b/sys/dev/bnxt/bnxt_en/bnxt_hwrm.c
similarity index 62%
rename from sys/dev/bnxt/bnxt_hwrm.c
rename to sys/dev/bnxt/bnxt_en/bnxt_hwrm.c
index 88ba185e2c27..9252964900ff 100644
--- a/sys/dev/bnxt/bnxt_hwrm.c
+++ b/sys/dev/bnxt/bnxt_en/bnxt_hwrm.c
@@ -2323,120 +3011,72 @@ static void bnxt_hwrm_set_coal_params(struct bnxt_softc *softc, uint32_t max_fra
 
 int bnxt_hwrm_set_coal(struct bnxt_softc *softc)
 {
-        int i, rc = 0;
-        struct hwrm_ring_cmpl_ring_cfg_aggint_params_input req_rx = {0},
-                                                           req_tx = {0}, *req;
-        uint16_t max_buf, max_buf_irq;
-        uint16_t buf_tmr, buf_tmr_irq;
-        uint32_t flags;
+	int i, rc = 0;
+	struct hwrm_ring_cmpl_ring_cfg_aggint_params_input req_rx = {0},
+							   req_tx = {0}, *req;
+	uint16_t max_buf, max_buf_irq;
+	uint16_t buf_tmr, buf_tmr_irq;
+	uint32_t flags;
 
-        bnxt_hwrm_cmd_hdr_init(softc, &req_rx,
-                               HWRM_RING_CMPL_RING_CFG_AGGINT_PARAMS);
-        bnxt_hwrm_cmd_hdr_init(softc, &req_tx,
-                               HWRM_RING_CMPL_RING_CFG_AGGINT_PARAMS);
+	bnxt_hwrm_cmd_hdr_init(softc, &req_rx,
+			       HWRM_RING_CMPL_RING_CFG_AGGINT_PARAMS);
+	bnxt_hwrm_cmd_hdr_init(softc, &req_tx,
+			       HWRM_RING_CMPL_RING_CFG_AGGINT_PARAMS);
 
-        /* Each rx completion (2 records) should be DMAed immediately.
-         * DMA 1/4 of the completion buffers at a time.
-         */
-        max_buf = min_t(uint16_t, softc->rx_coal_frames / 4, 2);
-        /* max_buf must not be zero */
-        max_buf = clamp_t(uint16_t, max_buf, 1, 63);
-        max_buf_irq = clamp_t(uint16_t, softc->rx_coal_frames_irq, 1, 63);
-        buf_tmr = BNXT_USEC_TO_COAL_TIMER(softc->rx_coal_usecs);
-        /* buf timer set to 1/4 of interrupt timer */
-        buf_tmr = max_t(uint16_t, buf_tmr / 4, 1);
-        buf_tmr_irq = BNXT_USEC_TO_COAL_TIMER(softc->rx_coal_usecs_irq);
-        buf_tmr_irq = max_t(uint16_t, buf_tmr_irq, 1);
-
-        flags = HWRM_RING_CMPL_RING_CFG_AGGINT_PARAMS_INPUT_FLAGS_TIMER_RESET;
-
-        /* RING_IDLE generates more IRQs for lower latency.  Enable it only
-         * if coal_usecs is less than 25 us.
-         */
-        if (softc->rx_coal_usecs < 25)
-                flags |= HWRM_RING_CMPL_RING_CFG_AGGINT_PARAMS_INPUT_FLAGS_RING_IDLE;
-
-        bnxt_hwrm_set_coal_params(softc, max_buf_irq << 16 | max_buf,
-                                  buf_tmr_irq << 16 | buf_tmr, flags, &req_rx);
-
-        /* max_buf must not be zero */
-        max_buf = clamp_t(uint16_t, softc->tx_coal_frames, 1, 63);
-        max_buf_irq = clamp_t(uint16_t, softc->tx_coal_frames_irq, 1, 63);
-        buf_tmr = BNXT_USEC_TO_COAL_TIMER(softc->tx_coal_usecs);
-        /* buf timer set to 1/4 of interrupt timer */
-        buf_tmr = max_t(uint16_t, buf_tmr / 4, 1);
-        buf_tmr_irq = BNXT_USEC_TO_COAL_TIMER(softc->tx_coal_usecs_irq);
-        buf_tmr_irq = max_t(uint16_t, buf_tmr_irq, 1);
-        flags = HWRM_RING_CMPL_RING_CFG_AGGINT_PARAMS_INPUT_FLAGS_TIMER_RESET;
-        bnxt_hwrm_set_coal_params(softc, max_buf_irq << 16 | max_buf,
-                                  buf_tmr_irq << 16 | buf_tmr, flags, &req_tx);
-
-        for (i = 0; i < softc->nrxqsets; i++) {
+	/* Each rx completion (2 records) should be DMAed immediately.
+	 * DMA 1/4 of the completion buffers at a time.
+	 */
+	max_buf = min_t(uint16_t, softc->rx_coal_frames / 4, 2);
+	/* max_buf must not be zero */
+	max_buf = clamp_t(uint16_t, max_buf, 1, 63);
+	max_buf_irq = clamp_t(uint16_t, softc->rx_coal_frames_irq, 1, 63);
+	buf_tmr = BNXT_USEC_TO_COAL_TIMER(softc->rx_coal_usecs);
+	/* buf timer set to 1/4 of interrupt timer */
+	buf_tmr = max_t(uint16_t, buf_tmr / 4, 1);
+	buf_tmr_irq = BNXT_USEC_TO_COAL_TIMER(softc->rx_coal_usecs_irq);
+	buf_tmr_irq = max_t(uint16_t, buf_tmr_irq, 1);
+
+	flags = HWRM_RING_CMPL_RING_CFG_AGGINT_PARAMS_INPUT_FLAGS_TIMER_RESET;
+
+	/* RING_IDLE generates more IRQs for lower latency.  Enable it only
+	 * if coal_usecs is less than 25 us.
+	 */
+	if (softc->rx_coal_usecs < 25)
+		flags |= HWRM_RING_CMPL_RING_CFG_AGGINT_PARAMS_INPUT_FLAGS_RING_IDLE;
+
+	bnxt_hwrm_set_coal_params(softc, max_buf_irq << 16 | max_buf,
+				  buf_tmr_irq << 16 | buf_tmr, flags, &req_rx);
+
+	/* max_buf must not be zero */
+	max_buf = clamp_t(uint16_t, softc->tx_coal_frames, 1, 63);
+	max_buf_irq = clamp_t(uint16_t, softc->tx_coal_frames_irq, 1, 63);
+	buf_tmr = BNXT_USEC_TO_COAL_TIMER(softc->tx_coal_usecs);
+	/* buf timer set to 1/4 of interrupt timer */
+	buf_tmr = max_t(uint16_t, buf_tmr / 4, 1);
+	buf_tmr_irq = BNXT_USEC_TO_COAL_TIMER(softc->tx_coal_usecs_irq);
+	buf_tmr_irq = max_t(uint16_t, buf_tmr_irq, 1);
+	flags = HWRM_RING_CMPL_RING_CFG_AGGINT_PARAMS_INPUT_FLAGS_TIMER_RESET;
+	bnxt_hwrm_set_coal_params(softc, max_buf_irq << 16 | max_buf,
+				  buf_tmr_irq << 16 | buf_tmr, flags, &req_tx);
+
+	for (i = 0; i < softc->nrxqsets; i++) {
 
 		req = &req_rx;
-                /*
-                 * TBD:
-		 *      Check if Tx also needs to be done
-                 *      So far, Tx processing has been done in softirq contest
-                 *
-		 * req = &req_tx;
-		 */
 		req->ring_id = htole16(softc->grp_info[i].cp_ring_id);
 
-                rc = hwrm_send_message(softc, req, sizeof(*req));
-                if (rc)
-                        break;
-        }
-        return rc;
-}
-
-int bnxt_hwrm_func_rgtr_async_events(struct bnxt_softc *softc, unsigned long *bmap,
-                                     int bmap_size)
-{
-	struct hwrm_func_drv_rgtr_input req = {0};
-	bitstr_t *async_events_bmap;
-	uint32_t *events;
-	int i;
-
-#define BNXT_MAX_NUM_ASYNC_EVENTS 256
-	async_events_bmap = bit_alloc(BNXT_MAX_NUM_ASYNC_EVENTS, M_DEVBUF,
-			M_WAITOK|M_ZERO);
-	events = (uint32_t *)async_events_bmap;
-
-	bnxt_hwrm_cmd_hdr_init(softc, &req, HWRM_FUNC_DRV_RGTR);
-
-	req.enables =
-		htole32(HWRM_FUNC_DRV_RGTR_INPUT_ENABLES_ASYNC_EVENT_FWD);
-
-	memset(async_events_bmap, 0, sizeof(BNXT_MAX_NUM_ASYNC_EVENTS / 8));
-
-	bit_set(async_events_bmap, HWRM_ASYNC_EVENT_CMPL_EVENT_ID_LINK_STATUS_CHANGE);
-	bit_set(async_events_bmap, HWRM_ASYNC_EVENT_CMPL_EVENT_ID_PF_DRVR_UNLOAD);
-	bit_set(async_events_bmap, HWRM_ASYNC_EVENT_CMPL_EVENT_ID_PORT_CONN_NOT_ALLOWED);
-	bit_set(async_events_bmap, HWRM_ASYNC_EVENT_CMPL_EVENT_ID_VF_CFG_CHANGE);
-	bit_set(async_events_bmap, HWRM_ASYNC_EVENT_CMPL_EVENT_ID_LINK_SPEED_CFG_CHANGE);
-
-	if (bmap && bmap_size) {
-		for (i = 0; i < bmap_size; i++) {
-			if (bit_test(bmap, i))
-				bit_set(async_events_bmap, i);
-		}
+		rc = hwrm_send_message(softc, req, sizeof(*req));
+		if (rc)
+			break;
 	}
-
-	for (i = 0; i < 8; i++)
-		req.async_event_fwd[i] |= htole32(events[i]);
-
-	free(async_events_bmap, M_DEVBUF);
-
-	return hwrm_send_message(softc, &req, sizeof(req));
+	return rc;
 }
 
 void bnxt_hwrm_ring_info_get(struct bnxt_softc *softc, uint8_t ring_type,
-                                       uint32_t ring_id,  uint32_t *prod, uint32_t *cons)
+			     uint32_t ring_id, uint32_t *prod, uint32_t *cons)
 {
-        hwrm_dbg_ring_info_get_input_t req = {0};
-        hwrm_dbg_ring_info_get_output_t *resp = (void *)softc->hwrm_cmd_resp.idi_vaddr;
-        int rc = 0;
+	hwrm_dbg_ring_info_get_input_t req = {0};
+	hwrm_dbg_ring_info_get_output_t *resp = (void *)softc->hwrm_cmd_resp.idi_vaddr;
+	int rc = 0;
 
 	*prod = *cons = 0xffffffff;
 	bnxt_hwrm_cmd_hdr_init(softc, &req, HWRM_DBG_RING_INFO_GET);
diff --git a/sys/dev/bnxt/bnxt_hwrm.h b/sys/dev/bnxt/bnxt_en/bnxt_hwrm.h
similarity index 88%
rename from sys/dev/bnxt/bnxt_hwrm.h
rename to sys/dev/bnxt/bnxt_en/bnxt_hwrm.h
index e016677707ce..126cad977c82 100644
--- a/sys/dev/bnxt/bnxt_hwrm.h
+++ b/sys/dev/bnxt/bnxt_en/bnxt_hwrm.h
@@ -32,12 +32,15 @@
 
 #define BNXT_PAUSE_TX 	 (HWRM_PORT_PHY_QCFG_OUTPUT_PAUSE_TX)
 #define BNXT_PAUSE_RX 	 (HWRM_PORT_PHY_QCFG_OUTPUT_PAUSE_RX)
-#define BNXT_AUTO_PAUSE_AUTONEG_PAUSE  				\
-        (HWRM_PORT_PHY_QCFG_OUTPUT_AUTO_PAUSE_AUTONEG_PAUSE)
+#define BNXT_AUTO_PAUSE_AUTONEG_PAUSE				\
+	(HWRM_PORT_PHY_QCFG_OUTPUT_AUTO_PAUSE_AUTONEG_PAUSE)
 #define BNXT_HWRM_SHORT_REQ_LEN	sizeof(struct hwrm_short_input)
 #define BNXT_BACKING_STORE_CFG_LEGACY_LEN       256
+#define SHORT_HWRM_CMD_TIMEOUT			500
 
 /* HWRM Function Prototypes */
+int
+hwrm_send_message(struct bnxt_softc *softc, void *msg, uint32_t msg_len);
 int bnxt_alloc_hwrm_dma_mem(struct bnxt_softc *softc);
 void bnxt_free_hwrm_dma_mem(struct bnxt_softc *softc);
 int bnxt_hwrm_ring_alloc(struct bnxt_softc *softc, uint8_t type,
@@ -45,8 +48,9 @@ int bnxt_hwrm_ring_alloc(struct bnxt_softc *softc, uint8_t type,
 int bnxt_hwrm_ring_free(struct bnxt_softc *softc, uint32_t type,
 		struct bnxt_ring *ring, int cmpl_ring_id);
 int bnxt_hwrm_ver_get(struct bnxt_softc *softc);
-int bnxt_hwrm_queue_qportcfg(struct bnxt_softc *softc);
-int bnxt_hwrm_func_drv_rgtr(struct bnxt_softc *softc);
+int bnxt_hwrm_queue_qportcfg(struct bnxt_softc *softc, uint32_t path_dir);
+int bnxt_hwrm_func_drv_rgtr(struct bnxt_softc *bp, unsigned long *bmap, int bmap_size,
+			    bool async_only);
 int bnxt_hwrm_func_drv_unrgtr(struct bnxt_softc *softc, bool shutdown);
 int bnxt_hwrm_func_qcaps(struct bnxt_softc *softc);
 int bnxt_hwrm_func_qcfg(struct bnxt_softc *softc);
@@ -64,6 +68,7 @@ int bnxt_hwrm_stat_ctx_alloc(struct bnxt_softc *softc, struct bnxt_cp_ring *cpr,
     uint64_t paddr);
 int bnxt_hwrm_stat_ctx_free(struct bnxt_softc *softc, struct bnxt_cp_ring *cpr);
 int bnxt_hwrm_port_qstats(struct bnxt_softc *softc);
+int bnxt_hwrm_port_qstats_ext(struct bnxt_softc *softc);
 int bnxt_hwrm_ring_grp_alloc(struct bnxt_softc *softc,
     struct bnxt_grp_info *grp);
 int bnxt_hwrm_ring_grp_free(struct bnxt_softc *softc, struct bnxt_grp_info *gr);
@@ -115,18 +120,25 @@ int bnxt_hwrm_fw_set_time(struct bnxt_softc *softc, uint16_t year,
     uint8_t month, uint8_t day, uint8_t hour, uint8_t minute, uint8_t second,
     uint16_t millisecond, uint16_t zone);
 int bnxt_hwrm_port_phy_qcfg(struct bnxt_softc *softc);
+int bnxt_hwrm_phy_qcaps(struct bnxt_softc *softc);
 uint16_t bnxt_hwrm_get_wol_fltrs(struct bnxt_softc *softc, uint16_t handle);
 int bnxt_hwrm_alloc_wol_fltr(struct bnxt_softc *softc);
 int bnxt_hwrm_free_wol_fltr(struct bnxt_softc *softc);
 int bnxt_hwrm_set_coal(struct bnxt_softc *softc);
 int bnxt_hwrm_func_rgtr_async_events(struct bnxt_softc *softc, unsigned long *bmap,
-                                     int bmap_size);
+				     int bmap_size);
 int bnxt_hwrm_func_backing_store_qcaps(struct bnxt_softc *softc);
 int bnxt_hwrm_func_backing_store_cfg(struct bnxt_softc *softc, uint32_t);
+int bnxt_hwrm_func_backing_store_cfg_v2(struct bnxt_softc *softc,
+					struct bnxt_ctx_mem_type *ctxm,
+					bool last);
 int bnxt_hwrm_func_resc_qcaps(struct bnxt_softc *softc, bool all);
 int bnxt_hwrm_reserve_pf_rings (struct bnxt_softc *softc);
 void bnxt_hwrm_ring_info_get(struct bnxt_softc *softc, uint8_t ring_type,
-                             uint32_t ring_id,  uint32_t *prod, uint32_t *);
+			     uint32_t ring_id, uint32_t *prod, uint32_t *);
 int bnxt_hwrm_passthrough(struct bnxt_softc *softc, void *req, uint32_t req_len,
 			  void *resp, uint32_t resp_len, uint32_t timeout);
+int	_hwrm_send_message(struct bnxt_softc *, void *, uint32_t);
+int	hwrm_send_message(struct bnxt_softc *, void *, uint32_t);
+void	bnxt_hwrm_cmd_hdr_init(struct bnxt_softc *, void *, uint16_t);
 #endif
diff --git a/sys/dev/bnxt/bnxt_mgmt.c b/sys/dev/bnxt/bnxt_en/bnxt_mgmt.c
similarity index 85%
rename from sys/dev/bnxt/bnxt_mgmt.c
rename to sys/dev/bnxt/bnxt_en/bnxt_mgmt.c
index 7185fa2f5c0a..2f82580352cb 100644
--- a/sys/dev/bnxt/bnxt_mgmt.c
+++ b/sys/dev/bnxt/bnxt_en/bnxt_mgmt.c
@@ -95,6 +95,70 @@ bnxt_mgmt_loader(struct module *m, int what, void *arg)
 	return (error);
 }
 
+static int
+bnxt_mgmt_process_dcb(struct cdev *dev, u_long cmd, caddr_t data,
+		       int flag, struct thread *td)
+{
+	struct bnxt_softc *softc = NULL;
+	struct bnxt_mgmt_dcb mgmt_dcb = {};
+	void *user_ptr;
+	int ret = 0;
+
+	memcpy(&user_ptr, data, sizeof(user_ptr));
+	if (copyin(user_ptr, &mgmt_dcb, sizeof(mgmt_dcb))) {
+		printf("%s: %s:%d Failed to copy data from user\n",
+			DRIVER_NAME, __FUNCTION__, __LINE__);
+		return -EFAULT;
+	}
+	softc = bnxt_find_dev(mgmt_dcb.hdr.domain, mgmt_dcb.hdr.bus,
+			      mgmt_dcb.hdr.devfn, NULL);
+	if (!softc) {
+		printf("%s: %s:%d unable to find softc reference\n",
+			DRIVER_NAME, __FUNCTION__, __LINE__);
+		return -ENODEV;
+	}
+
+	switch (mgmt_dcb.op) {
+	case BNXT_MGMT_DCB_GET_ETS:
+		bnxt_dcb_ieee_getets(softc, &mgmt_dcb.req.ets);
+		break;
+	case BNXT_MGMT_DCB_SET_ETS:
+		bnxt_dcb_ieee_setets(softc, &mgmt_dcb.req.ets);
+		break;
+	case BNXT_MGMT_DCB_GET_PFC:
+		bnxt_dcb_ieee_getpfc(softc, &mgmt_dcb.req.pfc);
+		break;
+	case BNXT_MGMT_DCB_SET_PFC:
+		bnxt_dcb_ieee_setpfc(softc, &mgmt_dcb.req.pfc);
+		break;
+	case BNXT_MGMT_DCB_SET_APP:
+		bnxt_dcb_ieee_setapp(softc, &mgmt_dcb.req.app_tlv.app[0]);
+		break;
+	case BNXT_MGMT_DCB_DEL_APP:
+		bnxt_dcb_ieee_delapp(softc, &mgmt_dcb.req.app_tlv.app[0]);
+		break;
+	case BNXT_MGMT_DCB_LIST_APP:
+		bnxt_dcb_ieee_listapp(softc, &mgmt_dcb.req.app_tlv.app[0],
+				      &mgmt_dcb.req.app_tlv.num_app);
+		break;
+	default:
+		device_printf(softc->dev, "%s:%d Invalid op 0x%x\n",
+			      __FUNCTION__, __LINE__, mgmt_dcb.op);
+		ret = -EFAULT;
+		goto end;
+	}
+
+	if (copyout(&mgmt_dcb, user_ptr, sizeof(mgmt_dcb))) {
+		device_printf(softc->dev, "%s:%d Failed to copy response to user\n",
+			      __FUNCTION__, __LINE__);
+		ret = -EFAULT;
+		goto end;
+	}
+
+end:
+	return ret;
+}
+
 static int
 bnxt_mgmt_process_hwrm(struct cdev *dev, u_long cmd, caddr_t data,
 		       int flag, struct thread *td)
@@ -345,9 +409,12 @@ bnxt_mgmt_ioctl(struct cdev *dev, u_long cmd, caddr_t data, int flag,
 		break;
 	case BNXT_MGMT_OPCODE_PASSTHROUGH_HWRM:
 		mtx_lock(&mgmt_lock);
-		ret = bnxt_mgmt_process_hwrm(dev, cmd, data, flag, td); 
+		ret = bnxt_mgmt_process_hwrm(dev, cmd, data, flag, td);
 		mtx_unlock(&mgmt_lock);
 		break;
+	case BNXT_MGMT_OPCODE_DCB_OPS:
+		ret = bnxt_mgmt_process_dcb(dev, cmd, data, flag, td);
+		break;
 	default:
 		printf("%s: Unknown command 0x%lx\n", DRIVER_NAME, cmd);
 		ret = -EINVAL;
diff --git a/sys/dev/bnxt/bnxt_mgmt.h b/sys/dev/bnxt/bnxt_en/bnxt_mgmt.h
similarity index 83%
rename from sys/dev/bnxt/bnxt_mgmt.h
rename to sys/dev/bnxt/bnxt_en/bnxt_mgmt.h
index f130ad386809..8489a223adef 100644
--- a/sys/dev/bnxt/bnxt_mgmt.h
+++ b/sys/dev/bnxt/bnxt_en/bnxt_mgmt.h
@@ -41,6 +41,7 @@
 
 #define	BNXT_MGMT_OPCODE_GET_DEV_INFO		0x80000000
 #define	BNXT_MGMT_OPCODE_PASSTHROUGH_HWRM	0x80000001
+#define	BNXT_MGMT_OPCODE_DCB_OPS		0x80000002
 
 #define BNXT_MGMT_MAX_HWRM_REQ_LENGTH		HWRM_MAX_REQ_LEN
 #define BNXT_MGMT_MAX_HWRM_RESP_LENGTH		(512)
@@ -118,9 +119,31 @@ struct bnxt_mgmt_req_hdr {
 };
 
 struct bnxt_mgmt_req {
-        struct bnxt_mgmt_req_hdr hdr;
-        union {
-            uint64_t hreq;
-        } req;
+	struct bnxt_mgmt_req_hdr hdr;
+	union {
+		uint64_t hreq;
+	} req;
 };
 
+struct bnxt_mgmt_app_tlv {
+	uint32_t num_app;
+	struct bnxt_dcb_app app[128];
+} __attribute__ ((__packed__));
+
+struct bnxt_mgmt_dcb {
+	struct bnxt_mgmt_req_hdr hdr;
+#define BNXT_MGMT_DCB_GET_ETS	0x1
+#define BNXT_MGMT_DCB_SET_ETS	0x2
+#define BNXT_MGMT_DCB_GET_PFC	0x3
+#define BNXT_MGMT_DCB_SET_PFC	0x4
+#define BNXT_MGMT_DCB_SET_APP	0x5
+#define BNXT_MGMT_DCB_DEL_APP	0x6
+#define BNXT_MGMT_DCB_LIST_APP	0x7
+#define BNXT_MGMT_DCB_MAX	BNXT_MGMT_DCB_LIST_APP
+	uint32_t op;
+	union {
+		struct bnxt_ieee_ets ets;
+		struct bnxt_ieee_pfc pfc;
+		struct bnxt_mgmt_app_tlv app_tlv;
+	} req;
+} __attribute__ ((__packed__));
diff --git a/sys/dev/bnxt/bnxt_sysctl.c b/sys/dev/bnxt/bnxt_en/bnxt_sysctl.c
similarity index 54%
rename from sys/dev/bnxt/bnxt_sysctl.c
rename to sys/dev/bnxt/bnxt_en/bnxt_sysctl.c
index 893e56b61099..cf4e995e1aba 100644
--- a/sys/dev/bnxt/bnxt_sysctl.c
+++ b/sys/dev/bnxt/bnxt_en/bnxt_sysctl.c
@@ -29,11 +29,18 @@
 #include <sys/cdefs.h>
 #include <sys/types.h>
 #include <sys/sysctl.h>
+#include <sys/ctype.h>
+#include <linux/delay.h>
 
 #include "bnxt.h"
 #include "bnxt_hwrm.h"
 #include "bnxt_sysctl.h"
 
+DEFINE_MUTEX(tmp_mutex); /* mutex lock for driver */
+extern void bnxt_fw_reset(struct bnxt_softc *bp);
+extern void bnxt_queue_sp_work(struct bnxt_softc *bp);
+extern void
+process_nq(struct bnxt_softc *softc, uint16_t nqid);
 /*
  * We want to create:
  * dev.bnxt.0.hwstats.txq0
@@ -105,6 +112,16 @@ bnxt_init_sysctl_ctx(struct bnxt_softc *softc)
 		return ENOMEM;
 	}
 
+	sysctl_ctx_init(&softc->dcb_ctx);
+	ctx = device_get_sysctl_ctx(softc->dev);
+	softc->dcb_oid = SYSCTL_ADD_NODE(ctx,
+	    SYSCTL_CHILDREN(device_get_sysctl_tree(softc->dev)), OID_AUTO,
+	    "dcb", CTLFLAG_RD | CTLFLAG_MPSAFE, 0, "dcb");
+	if (!softc->dcb_oid) {
+		sysctl_ctx_free(&softc->dcb_ctx);
+		return ENOMEM;
+	}
+
 	return 0;
 }
 
@@ -151,6 +168,14 @@ bnxt_free_sysctl_ctx(struct bnxt_softc *softc)
 			softc->flow_ctrl_oid = NULL;
 	}
 
+	if (softc->dcb_oid != NULL) {
+		orc = sysctl_ctx_free(&softc->dcb_ctx);
+		if (orc)
+			rc = orc;
+		else
+			softc->dcb_oid = NULL;
+	}
+
 	return rc;
 }
 
@@ -233,17 +258,17 @@ bnxt_create_port_stats_sysctls(struct bnxt_softc *softc)
 	    &softc->tx_port_stats->tx_512b_1023b_frames,
 	    "Transmitted 512b 1023b frames");
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "tx_1024b_1518_frames", CTLFLAG_RD,
+	    "tx_1024b_1518b_frames", CTLFLAG_RD,
 	    &softc->tx_port_stats->tx_1024b_1518b_frames,
-	    "Transmitted 1024b 1518 frames");
+	    "Transmitted 1024b 1518b frames");
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
 	    "tx_good_vlan_frames", CTLFLAG_RD,
 	    &softc->tx_port_stats->tx_good_vlan_frames,
 	    "Transmitted good vlan frames");
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "tx_1519b_2047_frames", CTLFLAG_RD,
+	    "tx_1519b_2047b_frames", CTLFLAG_RD,
 	    &softc->tx_port_stats->tx_1519b_2047b_frames,
-	    "Transmitted 1519b 2047 frames");
+	    "Transmitted 1519b 2047b frames");
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
 	    "tx_2048b_4095b_frames", CTLFLAG_RD,
 	    &softc->tx_port_stats->tx_2048b_4095b_frames,
@@ -284,53 +309,9 @@ bnxt_create_port_stats_sysctls(struct bnxt_softc *softc)
 	    "tx_fcs_err_frames", CTLFLAG_RD,
 	    &softc->tx_port_stats->tx_fcs_err_frames,
 	    "Transmitted fcs err frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "tx_control_frames", CTLFLAG_RD,
-	    &softc->tx_port_stats->tx_control_frames,
-	    "Transmitted control frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "tx_oversz_frames", CTLFLAG_RD,
-	    &softc->tx_port_stats->tx_oversz_frames, "Transmitted oversz frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "tx_single_dfrl_frames", CTLFLAG_RD,
-	    &softc->tx_port_stats->tx_single_dfrl_frames,
-	    "Transmitted single dfrl frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "tx_multi_dfrl_frames", CTLFLAG_RD,
-	    &softc->tx_port_stats->tx_multi_dfrl_frames,
-	    "Transmitted multi dfrl frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "tx_single_coll_frames", CTLFLAG_RD,
-	    &softc->tx_port_stats->tx_single_coll_frames,
-	    "Transmitted single coll frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "tx_multi_coll_frames", CTLFLAG_RD,
-	    &softc->tx_port_stats->tx_multi_coll_frames,
-	    "Transmitted multi coll frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "tx_late_coll_frames", CTLFLAG_RD,
-	    &softc->tx_port_stats->tx_late_coll_frames,
-	    "Transmitted late coll frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "tx_excessive_coll_frames", CTLFLAG_RD,
-	    &softc->tx_port_stats->tx_excessive_coll_frames,
-	    "Transmitted excessive coll frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "tx_frag_frames", CTLFLAG_RD,
-	    &softc->tx_port_stats->tx_frag_frames, "Transmitted frag frames");
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
 	    "tx_err", CTLFLAG_RD,
 	    &softc->tx_port_stats->tx_err, "Transmitted err");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "tx_tagged_frames", CTLFLAG_RD,
-	    &softc->tx_port_stats->tx_tagged_frames, "Transmitted tagged frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "tx_dbl_tagged_frames", CTLFLAG_RD,
-	    &softc->tx_port_stats->tx_dbl_tagged_frames,
-	    "Transmitted dbl tagged frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "tx_runt_frames", CTLFLAG_RD,
-	    &softc->tx_port_stats->tx_runt_frames, "Transmitted runt frames");
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
 	    "tx_fifo_underruns", CTLFLAG_RD,
 	    &softc->tx_port_stats->tx_fifo_underruns,
@@ -417,7 +398,7 @@ bnxt_create_port_stats_sysctls(struct bnxt_softc *softc)
 	    &softc->rx_port_stats->rx_512b_1023b_frames,
 	    "Received 512b 1023b frames");
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_1024b_1518_frames", CTLFLAG_RD,
+	    "rx_1024b_1518b_frames", CTLFLAG_RD,
 	    &softc->rx_port_stats->rx_1024b_1518b_frames,
 	    "Received 1024b 1518 frames");
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
@@ -464,34 +445,10 @@ bnxt_create_port_stats_sysctls(struct bnxt_softc *softc)
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
 	    "rx_pfc_frames", CTLFLAG_RD,
 	    &softc->rx_port_stats->rx_pfc_frames, "Received pfc frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_unsupported_opcode_frames", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_unsupported_opcode_frames,
-	    "Received unsupported opcode frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_unsupported_da_pausepfc_frames", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_unsupported_da_pausepfc_frames,
-	    "Received unsupported da pausepfc frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_wrong_sa_frames", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_wrong_sa_frames,
-	    "Received wrong sa frames");
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
 	    "rx_align_err_frames", CTLFLAG_RD,
 	    &softc->rx_port_stats->rx_align_err_frames,
 	    "Received align err frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_oor_len_frames", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_oor_len_frames,
-	    "Received oor len frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_code_err_frames", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_code_err_frames,
-	    "Received code err frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_false_carrier_frames", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_false_carrier_frames,
-	    "Received false carrier frames");
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
 	    "rx_ovrsz_frames", CTLFLAG_RD,
 	    &softc->rx_port_stats->rx_ovrsz_frames,
@@ -504,14 +461,6 @@ bnxt_create_port_stats_sysctls(struct bnxt_softc *softc)
 	    "rx_mtu_err_frames", CTLFLAG_RD,
 	    &softc->rx_port_stats->rx_mtu_err_frames,
 	    "Received mtu err frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_match_crc_frames", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_match_crc_frames,
-	    "Received match crc frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_promiscuous_frames", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_promiscuous_frames,
-	    "Received promiscuous frames");
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
 	    "rx_tagged_frames", CTLFLAG_RD,
 	    &softc->rx_port_stats->rx_tagged_frames,
@@ -520,46 +469,10 @@ bnxt_create_port_stats_sysctls(struct bnxt_softc *softc)
 	    "rx_double_tagged_frames", CTLFLAG_RD,
 	    &softc->rx_port_stats->rx_double_tagged_frames,
 	    "Received double tagged frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_trunc_frames", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_trunc_frames,
-	    "Received trunc frames");
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
 	    "rx_good_frames", CTLFLAG_RD,
 	    &softc->rx_port_stats->rx_good_frames,
 	    "Received good frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_pfc_xon2xoff_frames_pri0", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_pfc_xon2xoff_frames_pri0,
-	    "Received pfc xon2xoff frames pri0");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_pfc_xon2xoff_frames_pri1", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_pfc_xon2xoff_frames_pri1,
-	    "Received pfc xon2xoff frames pri1");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_pfc_xon2xoff_frames_pri2", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_pfc_xon2xoff_frames_pri2,
-	    "Received pfc xon2xoff frames pri2");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_pfc_xon2xoff_frames_pri3", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_pfc_xon2xoff_frames_pri3,
-	    "Received pfc xon2xoff frames pri3");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_pfc_xon2xoff_frames_pri4", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_pfc_xon2xoff_frames_pri4,
-	    "Received pfc xon2xoff frames pri4");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_pfc_xon2xoff_frames_pri5", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_pfc_xon2xoff_frames_pri5,
-	    "Received pfc xon2xoff frames pri5");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_pfc_xon2xoff_frames_pri6", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_pfc_xon2xoff_frames_pri6,
-	    "Received pfc xon2xoff frames pri6");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_pfc_xon2xoff_frames_pri7", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_pfc_xon2xoff_frames_pri7,
-	    "Received pfc xon2xoff frames pri7");
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
 	    "rx_pfc_ena_frames_pri0", CTLFLAG_RD,
 	    &softc->rx_port_stats->rx_pfc_ena_frames_pri0,
@@ -599,9 +512,6 @@ bnxt_create_port_stats_sysctls(struct bnxt_softc *softc)
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
 	    "rx_undrsz_frames", CTLFLAG_RD,
 	    &softc->rx_port_stats->rx_undrsz_frames, "Received undrsz frames");
-	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
-	    "rx_frag_frames", CTLFLAG_RD,
-	    &softc->rx_port_stats->rx_frag_frames, "Received frag frames");
 	SYSCTL_ADD_QUAD(&softc->hw_stats, SYSCTL_CHILDREN(oid), OID_AUTO,
 	    "rx_eee_lpi_events", CTLFLAG_RD,
 	    &softc->rx_port_stats->rx_eee_lpi_events, "Received eee lpi events");
